#!/bin/bash -i

###Converted from AttractEasyModel by easy2model 1.3
### Generated by ATTRACT shell script generator version 0.8

set -u -e
if [ ! -f $ATTRACTDIR/attract ]; then
  echo 'Cannot find the ATTRACT binary in $ATTRACTDIR='\"$ATTRACTDIR\"
  echo 'Please install ATTRACT following the installation instructions'
  echo 'ATTRACT is available at: http://www.attract.ph.tum.de/services/ATTRACT/attract.tgz'
  exit 1
fi
if [ ! -f $ATTRACTDIR/../version ] ||  [ `awk '{print ($1 < 0.4)}' $ATTRACTDIR/../version` -eq 1 ]; then
  echo 'Your ATTRACT version is too old to run this protocol. Please download and install the latest version of ATTRACT'
  echo 'ATTRACT is available at: http://www.attract.ph.tum.de/services/ATTRACT/attract.tgz'
  exit 1
fi
trap "kill -- -$BASHPID; attractclean" ERR EXIT
$ATTRACTDIR/shm-clean

rm -rf result.dat result.pdb result.lrmsd result.irmsd result.fnat result.interface >& /dev/null
function attractclean {
  $ATTRACTDIR/shm-clean
}

#name of the run
name=AAA

#docking parameters
params="$ATTRACTDIR/../attract.par receptorr.pdb partner2-ensemble/model-1r.pdb --fix-receptor --ens 2 partner2-ensemble.list --gravity 2"
scoreparams="$ATTRACTDIR/../attract.par receptorr.pdb partner2-ensemble/model-1r.pdb --score --fix-receptor --ens 2 partner2-ensemble.list"

#grid parameters
gridparams=" --grid 1 receptorgrid.gridheader"

#parallelization parameters
parals="--np 4 --chunks 4"

#see if pypy is installed
PYPY=python2
command -v pypy >/dev/null 2>&1 && PYPY=pypy

if [ 1 -eq 1 ]; then ### move and change to disable parts of the protocol

echo '**************************************************************'
echo 'Reduce partner PDBs...'
echo '**************************************************************'
python2 $ATTRACTDIR/../allatom/aareduce.py receptor.pdb receptor-aa.pdb --chain A --dumppatch --pdb2pqr > receptor.mapping
python2 $ATTRACTTOOLS/reduce.py receptor-aa.pdb receptorr.pdb --chain A > /dev/null
rm -rf partner2-ensemble
mkdir partner2-ensemble
$ATTRACTTOOLS/splitmodel ligand.pdb partner2-ensemble/model 12 > /dev/null
cat /dev/null > partner2-ensemble.list
cat /dev/null > partner2-ensemble-aa.list
python2 $ATTRACTDIR/../allatom/aareduce.py partner2-ensemble/model-1.pdb partner2-ensemble/model-1-aa.pdb --chain B --rna --dumppatch --nalib > ligand.mapping
python2 $ATTRACTTOOLS/reduce.py partner2-ensemble/model-1-aa.pdb partner2-ensemble/model-1r.pdb --chain B --rna > /dev/null
echo partner2-ensemble/model-1r.pdb >> partner2-ensemble.list
echo partner2-ensemble/model-1-aa.pdb >> partner2-ensemble-aa.list
python2 $ATTRACTDIR/../allatom/aareduce.py partner2-ensemble/model-2.pdb partner2-ensemble/model-2-aa.pdb --chain B --rna --dumppatch --reference partner2-ensemble/model-1-aa.pdb --nalib > /dev/null
python2 $ATTRACTTOOLS/reduce.py partner2-ensemble/model-2-aa.pdb partner2-ensemble/model-2r.pdb --chain B --rna > /dev/null
echo partner2-ensemble/model-2r.pdb >> partner2-ensemble.list
echo partner2-ensemble/model-2-aa.pdb >> partner2-ensemble-aa.list
python2 $ATTRACTDIR/../allatom/aareduce.py partner2-ensemble/model-3.pdb partner2-ensemble/model-3-aa.pdb --chain B --rna --dumppatch --reference partner2-ensemble/model-1-aa.pdb --nalib > /dev/null
python2 $ATTRACTTOOLS/reduce.py partner2-ensemble/model-3-aa.pdb partner2-ensemble/model-3r.pdb --chain B --rna > /dev/null
echo partner2-ensemble/model-3r.pdb >> partner2-ensemble.list
echo partner2-ensemble/model-3-aa.pdb >> partner2-ensemble-aa.list
python2 $ATTRACTDIR/../allatom/aareduce.py partner2-ensemble/model-4.pdb partner2-ensemble/model-4-aa.pdb --chain B --rna --dumppatch --reference partner2-ensemble/model-1-aa.pdb --nalib > /dev/null
python2 $ATTRACTTOOLS/reduce.py partner2-ensemble/model-4-aa.pdb partner2-ensemble/model-4r.pdb --chain B --rna > /dev/null
echo partner2-ensemble/model-4r.pdb >> partner2-ensemble.list
echo partner2-ensemble/model-4-aa.pdb >> partner2-ensemble-aa.list
python2 $ATTRACTDIR/../allatom/aareduce.py partner2-ensemble/model-5.pdb partner2-ensemble/model-5-aa.pdb --chain B --rna --dumppatch --reference partner2-ensemble/model-1-aa.pdb --nalib > /dev/null
python2 $ATTRACTTOOLS/reduce.py partner2-ensemble/model-5-aa.pdb partner2-ensemble/model-5r.pdb --chain B --rna > /dev/null
echo partner2-ensemble/model-5r.pdb >> partner2-ensemble.list
echo partner2-ensemble/model-5-aa.pdb >> partner2-ensemble-aa.list
python2 $ATTRACTDIR/../allatom/aareduce.py partner2-ensemble/model-6.pdb partner2-ensemble/model-6-aa.pdb --chain B --rna --dumppatch --reference partner2-ensemble/model-1-aa.pdb --nalib > /dev/null
python2 $ATTRACTTOOLS/reduce.py partner2-ensemble/model-6-aa.pdb partner2-ensemble/model-6r.pdb --chain B --rna > /dev/null
echo partner2-ensemble/model-6r.pdb >> partner2-ensemble.list
echo partner2-ensemble/model-6-aa.pdb >> partner2-ensemble-aa.list
python2 $ATTRACTDIR/../allatom/aareduce.py partner2-ensemble/model-7.pdb partner2-ensemble/model-7-aa.pdb --chain B --rna --dumppatch --reference partner2-ensemble/model-1-aa.pdb --nalib > /dev/null
python2 $ATTRACTTOOLS/reduce.py partner2-ensemble/model-7-aa.pdb partner2-ensemble/model-7r.pdb --chain B --rna > /dev/null
echo partner2-ensemble/model-7r.pdb >> partner2-ensemble.list
echo partner2-ensemble/model-7-aa.pdb >> partner2-ensemble-aa.list
python2 $ATTRACTDIR/../allatom/aareduce.py partner2-ensemble/model-8.pdb partner2-ensemble/model-8-aa.pdb --chain B --rna --dumppatch --reference partner2-ensemble/model-1-aa.pdb --nalib > /dev/null
python2 $ATTRACTTOOLS/reduce.py partner2-ensemble/model-8-aa.pdb partner2-ensemble/model-8r.pdb --chain B --rna > /dev/null
echo partner2-ensemble/model-8r.pdb >> partner2-ensemble.list
echo partner2-ensemble/model-8-aa.pdb >> partner2-ensemble-aa.list
python2 $ATTRACTDIR/../allatom/aareduce.py partner2-ensemble/model-9.pdb partner2-ensemble/model-9-aa.pdb --chain B --rna --dumppatch --reference partner2-ensemble/model-1-aa.pdb --nalib > /dev/null
python2 $ATTRACTTOOLS/reduce.py partner2-ensemble/model-9-aa.pdb partner2-ensemble/model-9r.pdb --chain B --rna > /dev/null
echo partner2-ensemble/model-9r.pdb >> partner2-ensemble.list
echo partner2-ensemble/model-9-aa.pdb >> partner2-ensemble-aa.list
python2 $ATTRACTDIR/../allatom/aareduce.py partner2-ensemble/model-10.pdb partner2-ensemble/model-10-aa.pdb --chain B --rna --dumppatch --reference partner2-ensemble/model-1-aa.pdb --nalib > /dev/null
python2 $ATTRACTTOOLS/reduce.py partner2-ensemble/model-10-aa.pdb partner2-ensemble/model-10r.pdb --chain B --rna > /dev/null
echo partner2-ensemble/model-10r.pdb >> partner2-ensemble.list
echo partner2-ensemble/model-10-aa.pdb >> partner2-ensemble-aa.list
python2 $ATTRACTDIR/../allatom/aareduce.py partner2-ensemble/model-11.pdb partner2-ensemble/model-11-aa.pdb --chain B --rna --dumppatch --reference partner2-ensemble/model-1-aa.pdb --nalib > /dev/null
python2 $ATTRACTTOOLS/reduce.py partner2-ensemble/model-11-aa.pdb partner2-ensemble/model-11r.pdb --chain B --rna > /dev/null
echo partner2-ensemble/model-11r.pdb >> partner2-ensemble.list
echo partner2-ensemble/model-11-aa.pdb >> partner2-ensemble-aa.list
python2 $ATTRACTDIR/../allatom/aareduce.py partner2-ensemble/model-12.pdb partner2-ensemble/model-12-aa.pdb --chain B --rna --dumppatch --reference partner2-ensemble/model-1-aa.pdb --nalib > /dev/null
python2 $ATTRACTTOOLS/reduce.py partner2-ensemble/model-12-aa.pdb partner2-ensemble/model-12r.pdb --chain B --rna > /dev/null
echo partner2-ensemble/model-12r.pdb >> partner2-ensemble.list
echo partner2-ensemble/model-12-aa.pdb >> partner2-ensemble-aa.list

echo '**************************************************************'
echo 'Generate starting structures...'
echo '**************************************************************'
cat $ATTRACTDIR/../rotation.dat > rotation.dat
$ATTRACTDIR/translate receptorr.pdb partner2-ensemble/model-1r.pdb > translate.dat
$ATTRACTDIR/systsearch > systsearch.dat
start=systsearch.dat

echo '**************************************************************'
echo 'ensemble search:'
echo ' add ensemble conformations to the starting structures'
echo '**************************************************************'

echo '**************************************************************'
echo 'random ensemble conformation in ligand 2 for each starting structure'
echo '**************************************************************'
$PYPY $ATTRACTTOOLS/ensemblize.py systsearch.dat 12 2 random  > systsearch-ens2.dat

echo '**************************************************************'
echo 'calculate receptorgrid grid'
echo '**************************************************************'
awk '{print substr($0,58,2)}' partner2-ensemble/model-1r.pdb | sort -nu > receptorgrid.alphabet
$ATTRACTDIR/make-grid-omp receptorr.pdb $ATTRACTDIR/../attract.par 5.0 7.0 receptorgrid.gridheader  --shm --alphabet receptorgrid.alphabet

echo '**************************************************************'
echo 'Docking'
echo '**************************************************************'

echo '**************************************************************'
echo '1st minimization'
echo '**************************************************************'
python2 $ATTRACTDIR/../protocols/attract.py systsearch-ens2.dat $params $gridparams --vmax 1000 $parals --output out_$name.dat

echo '**************************************************************'
echo 'Final rescoring'
echo '**************************************************************'
python2 $ATTRACTDIR/../protocols/attract.py out_$name.dat $scoreparams --rcut 50.0 $parals --output out_$name.score

echo '**************************************************************'
echo 'Merge the scores with the structures'
echo '**************************************************************'
$PYPY $ATTRACTTOOLS/fill-energies.py out_$name.dat out_$name.score > out_$name-scored.dat

echo '**************************************************************'
echo 'Sort structures'
echo '**************************************************************'
$PYPY $ATTRACTTOOLS/sort.py out_$name-scored.dat > out_$name-sorted.dat

echo '**************************************************************'
echo 'Remove redundant structures'
echo '**************************************************************'
$ATTRACTDIR/deredundant out_$name-sorted.dat 2 --ens 0 12 | $PYPY $ATTRACTTOOLS/fill-deredundant.py /dev/stdin out_$name-sorted.dat > out_$name-sorted-dr.dat

echo '**************************************************************'
echo 'Soft-link the final results'
echo '**************************************************************'
ln -s out_$name-sorted-dr.dat result.dat

echo '**************************************************************'
echo 'collect top 50 structures:'
echo '**************************************************************'
$ATTRACTTOOLS/top out_$name-sorted-dr.dat 50 > out_$name-top50.dat
$ATTRACTDIR/collect out_$name-top50.dat receptor-aa.pdb partner2-ensemble/model-1-aa.pdb --ens 2 partner2-ensemble-aa.list > out_$name-top50.pdb
ln -s out_$name-top50.pdb result.pdb

attractclean

fi ### move to disable parts of the protocol
